/* Copyright (c) 2015 Latchable, Inc
 * 
 * Created by Vandita Sharma 10/26/2015
 *
 * main.c
 */
 
/* the main file initializes all required peripherals and
 * waits for an inteerupt to be received    
*/

#include "latch.h"

void SVC_Handler(){return;}
void HardFault_Handler(){return;}

void system_init()
{

    mortise_init();
    i2c_gpio_init();
    latch_ble_init();
    //uart_init();
    if(!i2c_init())return;
    timers_init();
    int_received =0;
}

int main(void)
{
    system_init();
    // Configure the RAM retention parameters
    NRF_POWER->RAMON = POWER_RAMON_ONRAM0_RAM0On   << POWER_RAMON_ONRAM0_Pos
                     | POWER_RAMON_ONRAM1_RAM1On   << POWER_RAMON_ONRAM1_Pos
                     | POWER_RAMON_OFFRAM0_RAM0Off << POWER_RAMON_OFFRAM0_Pos
                     | POWER_RAMON_OFFRAM1_RAM1Off << POWER_RAMON_OFFRAM1_Pos;
    //timers start and wdt_init should be at the very end. just before while loop
    timers_start();
    wdt_init();
    while(1)
    {
        sd_app_evt_wait();
        if((int_received ==1)||(!nrf_gpio_pin_read(INTERRUPT)))
        {
            i2c_transfer();
            int_received=0;
        }
    }
}
